<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="套餐名称" prop="packageName">
        <el-input
            v-model="queryParams.packageName"
            placeholder="请输入套餐名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['xq:banner:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['xq:banner:remove']"
        >删除
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <el-table v-loading="loading" :data="tenantList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="租户套餐id" align="center" prop="packageId" v-if="false" />
      <el-table-column label="套餐名称" align="center" prop="packageName" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="状态" align="center" prop="status">
        <template #default="scope">
          <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" @click="handleStatusChange(scope.row)"></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" min-width="100">
        <template v-slot="scope">
          <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['xq:banner:edit']"
          >修改
          </el-button>
          <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['xq:banner:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
    />

    <add-or-update-tenant-package v-if="addOrUpdateTenantPackageVisible" ref="addOrUpdateTenantPackage" @refreshDataList="getList"/>
  </div>
</template>
<script>
import AddOrUpdateTenantPackage from '@/views/system/tenantPackage/add-or-update-tenant-package.vue'
import { changePackageStatus, delTenantPackage, listTenantPackage } from '@/api/system/tenantPackage'

export default {
  name: 'index',
  components: {AddOrUpdateTenantPackage},
  data() {
    return {
      addOrUpdateTenantPackageVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 借款状态表格数据
      tenantList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        packageName: undefined,
      },
    }
  },
  created() {
    this.getList();
  },
  methods: {
    handleStatusChange(row){
      let text = row.status === 0 ? '启用' : '停用'
      this.$confirm('确认要' + text + '[' + row.companyName + ']租户套餐吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return changePackageStatus(row.packageId, row.status);
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.openVideoStatus = row.openVideoStatus === 1 ? 0 : 1
      })
    },
    getList() {
      this.loading = true;
      listTenantPackage(this.queryParams).then(response => {
        this.tenantList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    handleUpdate(row){
      this.addOrUpdateTenantPackageVisible = true
      this.$nextTick(() => {
        this.$refs.addOrUpdateTenantPackage.init(row.packageId)
      })
    },
    handleAdd(){
      this.addOrUpdateTenantPackageVisible = true
      this.$nextTick(() => {
        this.$refs.addOrUpdateTenantPackage.init()
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除租户套餐【"' + row.packageName + '"】的数据项？').then(() => {
        this.loading = true;
        return delTenantPackage(row.packageId);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
  }
}
</script>
<style scoped lang="scss">

</style>
